#include <allegro.h>
#include "items.h"
#include "map.h"
#include "main.h"
#include "globals.h"

using namespace std;

static BITMAP* ItemImages[MAX_ITEMS];

bool LoadItemPictures()
{
    ItemImages[ITEM_LOCK] = load_bitmap(get_config_string("Items","Lock","Pics\\lock.pcx"),NULL);
    ItemImages[ITEM_HEALTH] = load_bitmap(get_config_string("Items","Health","Pics\\health.pcx"),NULL);
    ItemImages[ITEM_MONEY] = load_bitmap(get_config_string("Items","Money","Pics\\money.pcx"),NULL);
    ItemImages[ITEM_BOOK] = load_bitmap(get_config_string("Items","Book","Pics\\book.pcx"),NULL);
    ItemImages[ITEM_SHIP] = load_bitmap(get_config_string("Items","Ship","Pics\\ship.pcx"),NULL);
    ItemImages[ITEM_WIN] = load_bitmap(get_config_string("Items","Win","Pics\\win.pcx"),NULL);
    
    for (int i=0; i<MAX_ITEMS; i++)
       if (ItemImages[i] == NULL) return false;
    
    return true;
}

void DestroyItemPictures()
{
    for (int i=0; i<MAX_ITEMS; i++)
       destroy_bitmap(ItemImages[i]);
}    

// ---------------- CItem ----------------    

CItem :: CItem(int x, int y, int iType)
{
    this->x=x;
    this->y=y;
    this->iType=iType;
    this->bWasted = false;
    if ( (iType < 0) || (iType >= MAX_ITEMS) ) iType = 0;  // to avoid errors
    this->ItsPicture = new BITMAP*[1];   // only 1 sprite (for now!)
    this->ItsPicture[0] = ItemImages[iType];
    this->iMaxImageFrames= 1;
    this->iImageFrame = 0;
    this->w = ItsPicture[0]->w;
    this->h = ItsPicture[0]->h;
    // add this item to the appropriate list
    Items.push_back(this);
}
    
void CItem :: DoAction()
{
    switch (iType)
    {
        case ITEM_LOCK: break;
        case ITEM_HEALTH: break;
        case ITEM_WIN: break;
        case ITEM_MONEY: break;
        case ITEM_BOOK: break;
        case ITEM_SHIP: break;
    }    
}
    
void CItem :: DoDraw()
{
    draw_sprite(Offscreen,ItsPicture[iImageFrame],Map->iGlobalX,Map->iGlobalY);
    iImageFrame++;
    if (iImageFrame >= iMaxImageFrames) iImageFrame = 0;
}    
